<template>
  <div class="form-container flex flex-col gap-2">
    <label v-if="label" :for="attrs.id"> {{ label }} </label>
    <Textarea
      v-model="value"
      v-bind="$attrs"
      :name="name"
      :rules="rules"
      :invalid="invalid"
      class="form-textarea"
      :class="{
        'form-input--password': type === 'password',
        'w-full': wFull
      }"
    />
    <small v-if="length" class="form-length"
      >{{ getValueLength }}/{{ length }}</small
    >
    <small v-if="errorMessage" class="color-danger"> {{ errorMessage }} </small>
    <small v-if="small"> {{ small }} </small>
  </div>
</template>

<script lang="ts" setup>
import Textarea from 'primevue/textarea'

const attrs = useAttrs() as any
const emit = defineEmits(['update:modelValue'])

const props = defineProps({
  modelValue: {
    type: String,
    required: false,
    default: ''
  },
  label: {
    type: String,
    required: false
  },
  name: {
    type: String,
    required: true
  },
  rules: {
    type: String,
    required: false,
    default: ''
  },
  type: {
    type: String,
    required: false
  },
  small: {
    type: String,
    required: false
  },
  float: {
    type: Boolean,
    required: false
  },
  wFull: {
    type: Boolean,
    required: false
  },
  length: {
    type: [String, Number],
    required: false
  }
})

const invalid = computed(() => (errorMessage.value ? true : false))

const getValueLength = computed(() => {
  return value.value.length
})

const { value, errorMessage } = useField(props.name, props.rules, {
  initialValue: props.modelValue,
  syncVModel: true
})
</script>

<style lang="scss" scoped>
.form-length {
  float: right;
  text-align: right;
}
</style>
